#pragma once

class BinaryTree
{
public:
	BinaryTree();
	~BinaryTree();
	
	void Insert(int x);
	void InOrder();
	bool Search(int x);
	int Count();
	int MaxKey();
	int MinKey();

private:
	struct node
	{	
		int key;//klic, levy a pravy potomek
		node* left;
		node* right;
	};
	node* root;
	//privatni metody pro rekurzivni volani, obsahuji navic rekurzivni parametr, ukazatel na aktualne zpracovavany uzel stromu
	void Clear(node* nod);
	void Insert(int x, node*& nod);
	void InOrder(node* nod);
	bool Search(int x, node* nod);
	int Count(node* nod);
	int MaxKey(node* nod);
	int MinKey(node* nod);
};

